<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 06/17/2004 *
 * ================                             Last change: 06/17/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : ext-nickname.php                                 *
 * -------------------------------------------------------------------- *
 * Short description : Nickname login and display in register form      *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Nickname-Login und Anzeige im Anmeldeformular    *
 * -------------------------------------------------------------------- *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2007 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if ((ereg(basename(__FILE__), $_SERVER['PHP_SELF'])))
{
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), "/inc") + 4)."/security.php";
	require($INC);
}

// Version number
$EXT_VERSION = "0.1.7";

// Auto-set extension version
if (empty($EXT_VER)) $EXT_VER = $EXT_VERSION;

// Version history array (add more with , "0.1" and so on)
$EXT_VER_HISTORY = array("0.0", "0.0.1", "0.0.2", "0.0.3", "0.0.4", "0.0.5", "0.0.6", "0.0.7", "0.0.8", "0.0.9", "0.1.0", "0.1.1", "0.1.2", "0.1.3", "0.1.4", "0.1.5", "0.1.6", "0.1.7", "0.1.8");

switch ($EXT_LOAD_MODE)
{
case "register": // Do stuff when installtion is running (modules.php?module=admin&action=login is called)
	// SQL commands to run
	$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_user_data ADD nickname varchar(255) NOT NULL default ''";
	$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_user_data ADD nick_uid enum('nick', 'uid') NOT NULL default 'uid'";
	$SQLs[] = "INSERT INTO "._MYSQL_PREFIX."_member_menu (action, what, title, sort, visible, locked) VALUES ('main', 'nickname', 'Nicknamen', '5', 'Y', 'Y')";

	// Load CSS file?
	$EXT_CSS = "Y";
	break;

case "remove": // Do stuff when removing extension
	// SQL commands to run
	$SQLs[] = "DELETE LOW_PRIORITY FROM "._MYSQL_PREFIX."_member_menu WHERE action='main' AND what='nickname' LIMIT 1";
	$SQLs[] = "DELETE LOW_PRIORITY FROM "._MYSQL_PREFIX."_admin_menu WHERE what='config_nickname' LIMIT 1";
	break;

case "activate": // Do stuff when admin activates this extension
	// SQL commands to run
	$SQLs[] = "UPDATE "._MYSQL_PREFIX."_member_menu SET visible='Y', locked='N' WHERE action='main' AND what='nickname' LIMIT 1";
	break;

case "deactivate": // Do stuff when admin deactivates this extension
	// SQL commands to run
	$SQLs[] = "UPDATE "._MYSQL_PREFIX."_member_menu SET visible='Y', locked='Y' WHERE action='main' AND what='nickname' LIMIT 1";
	break;

case "update": // Update an extension
	switch ($EXT_VER)
	{
	case "0.0.1": // SQL queries for v0.0.1
		$SQLs[] = "UPDATE "._MYSQL_PREFIX."_extensions SET ext_has_css='Y' WHERE ext_name='nickname' AND ext_has_css='N' LIMIT 1";

		// This update depends on sql_patches update!
		$EXT_UPDATE_DEPENDS = "sql_patches";

		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "CSS-Datei kann per Adminbereich ein- und ausgeschaltet werden.";
		break;

	case "0.0.3": // SQL queries for v0.0.3
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Fehlende Abfrage im Mitlieder-Modul, on Erweiterung auch aktiviert ist.";
		break;

	case "0.0.4": // SQL queries for v0.0.4
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Wegen des Theme-Supportes hat sich die URL zur CSS-Datei ge&auml;ndert.";
		break;

	case "0.0.5": // SQL queries for v0.0.5
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Fehler beseitigt, wenn error_reporting=E_ALL gesetzt ist.";
		break;

	case "0.0.6": // SQL queries for v0.0.6
		$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_config ADD nickname_len tinyint(4) not null default '5'";
		$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_config ADD nickname_pattern varchar(255) not null default 'a-zA-Z0-9_'";
		$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_config ADD nickname_chars varchar(255) not null default 'a-z, A-Z, 0-9, _'";
		$SQLs[] = "INSERT INTO "._MYSQL_PREFIX."_admin_menu (action, what, title, descr, sort) VALUES('setup', 'config_nickname', 'Nicknamen', 'Stellen Sie minimale Nicknamenl&auml;nge, sowie erlaubte Zeichen hier ein.', 12)";

		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Minimale L&auml;nge, sowie erlaubte Zeichen sind per Adminbereich &auml;nderbar. Setzen Sie als erlaubte Zeichen nur URL-konforme Zeichen ein!";
		break;

	case "0.0.7": // SQL queries for v0.0.7
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Problem mit Speicherung der Einstellungen beseitigt.";
		break;

	case "0.0.8": // SQL queries for v0.0.8
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Men&uuml;punkte im Gast-/Mitgliedsbereich k&ouml;nnen nicht mehr aufgerufen werden, wenn die Erweiterung deaktiviert ist.";
		break;

	case "0.0.9": // SQL queries for v0.0.9
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Design &quot;Solid-Business&quot; eingebaut.";
		break;

	case "0.1.0": // SQL queries for v0.1.0
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Seit <A href=\"".SERVER_URL."/patches/340-Gast_Mitgliedsmenue_Deaktivieren.zip\">Patch 340</A> &uuml;berfl&uuml;ssige HTML-Tags entfernt.";
		break;

	case "0.1.1": // SQL queries for v0.1.1
		$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_user_data DROP nick_uid";

		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Auswahlf&uuml;r Mitglied ob mit Nickname oder User-ID einloggen entfernt.";
		break;

	case "0.1.2": // SQL queries for v0.1.2
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Zum Zusenden eines neuen Passwortes kann jetzt entweder der Nickname / User-ID <U>ODER</U> die angemeldete EMail-Adresse eingegeben werden.";
		break;

	case "0.1.3": // SQL queries for v0.1.3
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "CSS-Datei in general.css verschmolzen (Patch 435!)";
		break;

	case "0.1.4": // SQL queries for v0.1.4
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "HTML-Code ausgelagert in Templates und SQL-Anweisungen abgesichert.";
		break;

	case "0.1.5": // SQL queries for v0.1.5
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Abspeichern von Einstellungen repariert.";
		break;

	case "0.1.6": // SQL queries for v0.1.6
		$SQLs[] = "UPDATE "._MYSQL_PREFIX."_member_menu SET action='extras', sort='2' WHERE what='nickname' LIMIT 1";

		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Mitgliedsmen&uuml; komplett umgebaut.";
		break;

	case "0.1.7": // SQL queries for v0.1.7
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Mitglieder ohne Nickname sollten kein <strong>*failed*</strong> mehr sehen.";
		break;

	case "0.1.8": // SQL queries for v0.1.8
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Fehlerhinweis bei deaktivierter Erweiterung verbessert.";
		break;
	}
	break;

default: // Do stuff when extension is loaded
	$DUMMY = LOAD_CONFIG("0");
	define('__NICKNAME_LANG_CHARS', $DUMMY['nickname_chars']);
	define('__NICKNAME_LENGTH'    , $DUMMY['nickname_len']);
	define('__NICKNAME_PATTERN'   , $DUMMY['nickname_pattern']);
	unset($DUMMY);
	break;
}
// Language file prefix
$EXT_LANG_PREFIX = "nickname";

// Extension is always active?
$EXT_ALWAYS_ACTIVE = "N";

//
?>
