<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 04/11/2004 *
 * ================                             Last change: 11/15/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : ext-wernis.php                                   *
 * -------------------------------------------------------------------- *
 * Short description : Payout extension                                 *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Auszahlung-Erweiterung                           *
 * -------------------------------------------------------------------- *
 * Modified payout extension! See: http://www.mxchange.org for details  *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2007 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (ereg(basename(__FILE__), $_SERVER['PHP_SELF']))
{
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), "/inc") + 4)."/security.php";
	require($INC);
}

// Version of this extension
$EXT_VERSION = "0.0";

// Auto-set extension version
if (empty($EXT_VER)) $EXT_VER = $EXT_VERSION;

// Version history array (add more with , "0.1" and so on)
$EXT_VER_HISTORY = array("0.0");

switch ($EXT_LOAD_MODE)
{
case "register": // Do stuff when installtion is running (modules.php?module=admin&action=login is called)
	// SQL commands to run
	$SQLs[] = "DROP TABLE IF EXISTS "._MYSQL_PREFIX."_user_wernis";
	$SQLs[] = "CREATE TABLE "._MYSQL_PREFIX."_user_wernis (
id bigint(20) NOT NULL auto_increment,
userid bigint(20) NOT NULL default '0',
wernis_account varchar(255) NOT NULL default '',
wernis_amount double(22,5) NOT NULL default '0.00000',
wernis_timestamp varchar(10) NOT NULL default '0',
wernis_type ENUM('IN','OUT') NOT NULL default 'OUT',
KEY(userid),
PRIMARY KEY(id)
) TYPE=MyISAM";
	$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_config ADD wernis_min_amount bigint(20) not null default '40000'";
	$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_config ADD wernis_api_id bigint(20) not null default '0'";
	$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_config ADD wernis_api_md5 varchar(32) not null default ''";
	$SQLs[] = "INSERT INTO "._MYSQL_PREFIX."_admin_menu (action, what, title, descr, sort) VALUES('wernis', '', '{!POINTS!}-Management', 'Konfiguration zur WDS66-API einstellen, Auszahlungen auflisten usw..', 15)";
	$SQLs[] = "INSERT INTO "._MYSQL_PREFIX."_admin_menu (action, what, title, descr, sort) VALUES('wernis', 'config_wernis', 'WDS66-API-Einstellungen', 'Konfiguration zur WDS66-API einstellen.', 1)";
	$SQLs[] = "INSERT INTO "._MYSQL_PREFIX."_admin_menu (action, what, title, descr, sort) VALUES('wernis', 'list_wernis', '{!POINTS!}-Anfragen auflisten', 'Listet alle {!POINTS!}-Auszahlungsanfragen Ihrer Mitglieder auf.', 2)";
	$SQLs[] = "INSERT INTO "._MYSQL_PREFIX."_member_menu (action, what, title, visible, locked, sort) VALUES('main', 'wernis', '{!POINTS!}-Ein-/Auszahlungen', 'N', 'N', '11')";
	break;

case "remove": // Do stuff when removing extension
	// SQL commands to run
	$SQLs[] = "DROP TABLE IF EXISTS "._MYSQL_PREFIX."_user_wernis";
	$SQLs[] = "DELETE LOW_PRIORITY FROM "._MYSQL_PREFIX."_admin_menu WHERE action='wernis'";
	$SQLs[] = "DELETE LOW_PRIORITY FROM "._MYSQL_PREFIX."_member_menu WHERE action='main' AND what='wernis' LIMIT 1";
	break;

case "activate": // Do stuff when admin activates this extension
	// SQL commands to run
	$SQLs[] = "UPDATE "._MYSQL_PREFIX."_member_menu SET visible='Y', locked='N' WHERE action='main' AND what='wernis' LIMIT 1";
	break;

case "deactivate": // Do stuff when admin deactivates this extension
	// SQL commands to run
	$SQLs[] = "UPDATE "._MYSQL_PREFIX."_member_menu SET visible='Y', locked='Y' WHERE action='main' AND what='wernis' LIMIT 1";
	break;

case "update": // Update an extension
	switch ($EXT_VER)
	{
	case "0.0.1": // SQL queries for v0.0.1
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "";
		break;
	}
	break;

default: // Do stuff when extension is loaded
	$DUMMY = LOAD_CONFIG("0");
	$CONFIG['wernis_min_amount'] = $DUMMY['wernis_min_amount'];
	$CONFIG['wernis_api_id']     = $DUMMY['wernis_api_id'];
	$CONFIG['wernis_api_md5']    = $DUMMY['wernis_api_md5'];
	unset($DUMMY);
	break;
}
// Language file prefix
$EXT_LANG_PREFIX = "wernis";

// Extension is always active?
$EXT_ALWAYS_ACTIVE = "N";

//
?>
