<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 01/26/2005 *
 * ===============                              Last change: 01/26/2005 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : output_functions.php                             *
 * -------------------------------------------------------------------- *
 * Short description : Class containing the HTML sub-system             *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Klasse fuer das HTML-Subsystem                   *
 * -------------------------------------------------------------------- *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003, 2004, 2005, 2006, 2007 by Roland Haeder          *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (ereg(basename(__FILE__), $_SERVER['PHP_SELF']))
{
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), "/inc") + 4)."/security.php";
	require($INC);
}
// Add HTML to the output stream
class HTMLParser
{

// Initializer
function HTMLParser()
{
}

// Add HTML-Code to buffer
function add_html ($HTML, $NEW_LINE = true)
{
	global $OUTPUT;
}
// Compiles HTML code
function compile_html($code, $simple=false)
{
	global $SEC_CHARS;

	// Compile constants
	$code = str_replace("{--", '".', str_replace("--}", '."', $code));

	// Compile QUOT and other non-HTML codes
	foreach ($SEC_CHARS['to'] as $k=>$from)
	{
		// Do the reversed thing as in inc/libs/security_functions.php
		$code = str_replace($from, $SEC_CHARS['from'][$k], $code);
	}

	// But keep simple quotes for later use
	if ($simple) $code = str_replace("'", "{QUOT}", $code);

	// Return compiled code
	return $code;
}
// Load a template file and return it's content (only it's name; do not use ' or ")
function get_template ($template, $return=false, $content="")
{
	// Add more variables which you want to use in your template files
	global $DATA, $ACTION, $WHAT;
	$REFID = bigintval($_COOKIE['refid']);

	if ($template == "member_support_form")
	{
		// Support request of a member
		$ID = bigintval($_COOKIE['userid']);
		$result = SQL_QUERY_ESC("SELECT sex, surname, family FROM "._MYSQL_PREFIX."_user_data WHERE userid='%s' LIMIT 1", array($ID), __FILE__, __LINE__);
		list($sex, $surname, $family) = SQL_FETCHROW($result);
		SQL_FREERESULT($result);
		$salut = TRANSLATE_SEX($sex);
	}

	// Base directory
	$BASE = PATH."templates/".GET_LANGUAGE()."/html/";
	$MODE = "";

	// Check for admin/guest/member templates
	if (strpos($template, "admin_") > -1)
	{
		// Admin template found
		$MODE = "admin/";
	}
	 elseif (strpos($template, "guest_") > -1)
	{
		// Guest template found
		$MODE = "guest/";
	}
	 elseif (strpos($template, "member_") > -1)
	{
		// Member template found
		$MODE = "member/";
	}
	 elseif (strpos($template, "install_") > -1)
	{
		// Installation template found
		$MODE = "install/";
	}
	 elseif (strpos($template, "mailid_") > -1)
	{
		// Mail confirmation template found
		$MODE = "mailid/";
	}

	// Generate file name
	$file = $BASE.$MODE.$template.".tpl";
	if ((!empty($HTTP_GET_VARS['what'])) && ((strpos($template, "_header") > 0) || (strpos($template, "_footer") > 0)) && (($MODE == "guest/") || ($MODE == "member/") || ($MODE == "admin/")))
	{
		// Select what depended header/footer template file for admin/guest/member area
		$file2 = $BASE.$MODE.$template."_".$HTTP_GET_VARS['what'].".tpl";

		// Probe for it...
		if (file_exists($file2)) $file = $file2;

		// Remove variable from memory
		unset($file2);
	}

	// Does the special template exists?
	if (!file_exists($file))
	{
		// Reset to default template
		$file = PATH."templates/".GET_LANGUAGE()."/html/".$template.".tpl";
	}

	// Now does the final template exists?
	if (file_exists($file))
	{
		// The local file does exists so we load it. :)
		$tmpl_file = implode("", file($file));
		$tmpl_file = str_replace("'", "{QUOT}", $tmpl_file);

		// Compile and run code
		$ret = COMPILE_CODE(addslashes($tmpl_file), false, true);
		$ret = "<!-- Template ".$template." - Start -->\n".$ret."<!-- Template ".$template." - End -->\n";
	}
	 elseif (IS_ADMIN())
	{
		// Only admins shall see this warning
		$ret = "<BR><SPAN class=\"guest_failed\">".TEMPLATE_404."</SPAN><BR>
(".basename($file).")
<BR><BR>";
	}
	if ($return)
	{
		// Return the HTML code
		return $ret;
	}
	 else
	{
		// Output directly
		$this->add_html ($ret);
	}
}

	// END OF CLASS
}
//
?>
