<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 08/03/2004 *
 * ================                             Last change: 11/19/2005 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : task_functions.php                               *
 * -------------------------------------------------------------------- *
 * Short description : Special task functions                           *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Spezielle task-Funktionen                        *
 * -------------------------------------------------------------------- *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2007 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (ereg(basename(__FILE__), $_SERVER['PHP_SELF']))
{
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), "/inc") + 4)."/security.php";
	require($INC);
}
//
// The advanced overview shows detailed informations to your exchange script:
//  - Unconfirmed / locked accounts
//  - Mails waiting to be approved
//  - Open tasks
//  - Your own tasks
//  - ...
//
function OUTPUT_ADVANCED_OVERVIEW (&$result_main)
{
	global $_COOKIE, $CONFIG;

	// Init variables/arrays
	$EXTRAS = ""; $OUT = ""; $SQLs = array(); $WHATs = array(); $DESCRs = array(); $TITLEs = array();

	// Chheck for new extensions and updates
	$JOBS_DONE = OUTPUT_STANDARD_OVERVIEW($result_main);

	if (!$JOBS_DONE)
	{
		// New extensions or updates found
		$result = SQL_QUERY_ESC("SELECT id FROM "._MYSQL_PREFIX."_task_system WHERE assigned_admin='%s' AND status='NEW' AND task_type='EXTENSION_UPDATE'",
		 array(GET_ADMIN_ID($_COOKIE['admin_login'])), __FILE__, __LINE__);

		$value = SQL_NUMROWS($result);
		SQL_FREERESULT($result);

		if ($value > 0)
		{
			define ('__TASK_UPDATE_VALUE', "<A href=\"".URL."/modules.php?module=admin&amp;what=list_task&amp;type=updates\">".$value."</A>");
		}
		 else
		{
			define ('__TASK_UPDATE_VALUE', "0");
		}
	}
	 else
	{
		define ('__TASK_UPDATE_VALUE', "0");
	}

	//
	// First check for all account status seperately
	//
	// Confirmed accounts
	$result = SQL_QUERY("SELECT userid FROM "._MYSQL_PREFIX."_user_data WHERE status='CONFIRMED'", __FILE__, __LINE__);
	$value = SQL_NUMROWS($result);
	SQL_FREERESULT($result);

	if ($value > 0)
	{
		define('__CONFIRMED_VALUE', "<A href=\"".URL."/modules.php?module=admin&amp;what=list_user&amp;mode=confirmed\">".$value."</A>");
	}
	 else
	{
		define('__CONFIRMED_VALUE', "0");
	}
	// Unconfirmed accounts
	$result = SQL_QUERY("SELECT userid FROM "._MYSQL_PREFIX."_user_data WHERE status='UNCONFIRMED'", __FILE__, __LINE__);
	$value = SQL_NUMROWS($result);
	SQL_FREERESULT($result);

	if ($value > 0)
	{
		define('__UNCONFIRMED_VALUE', "<A href=\"".URL."/modules.php?module=admin&amp;what=chk_regs\">".$value."</A>");
	}
	 else
	{
		define('__UNCONFIRMED_VALUE', "0");
	}
	// And locked accounts
	$result = SQL_QUERY("SELECT userid FROM "._MYSQL_PREFIX."_user_data WHERE status='LOCKED'", __FILE__, __LINE__);
	$value = SQL_NUMROWS($result);
	SQL_FREERESULT($result);

	if ($value > 0)
	{
		define('__LOCKED_VALUE', "<A href=\"".URL."/modules.php?module=admin&amp;what=list_user&amp;mode=locked\">".$value."</A>");
	}
	 else
	{
		define('__LOCKED_VALUE', "0");
	}
	//
	// Unassigned tasks
	//
	$result = SQL_QUERY("SELECT id FROM "._MYSQL_PREFIX."_task_system WHERE assigned_admin='0' AND status != 'DELETED'", __FILE__, __LINE__);
	$value = SQL_NUMROWS($result);
	SQL_FREERESULT($result);

	if ($value > 0)
	{
		define('__TASK_NEW_VALUE', "<A href=\"".URL."/modules.php?module=admin&amp;what=list_task&amp;type=unassigned\">".$value."</A>");
	}
	 else
	{
		define('__TASK_NEW_VALUE', "0");
	}
	//
	// Closed tasks
	//
	$result = SQL_QUERY("SELECT id FROM "._MYSQL_PREFIX."_task_system WHERE status = 'CLOSED'", __FILE__, __LINE__);
	$value = SQL_NUMROWS($result);
	SQL_FREERESULT($result);

	if ($value > 0)
	{
		define('__TASK_CLOSED_VALUE', "<A href=\"".URL."/modules.php?module=admin&amp;what=list_task&amp;type=closed\">".$value."</A>");
	}
	 else
	{
		define('__TASK_CLOSED_VALUE', "0");
	}
	//
	// Deleted tasks
	//
	$result = SQL_QUERY("SELECT id FROM "._MYSQL_PREFIX."_task_system WHERE status = 'DELETED'", __FILE__, __LINE__);
	$value = SQL_NUMROWS($result);
	SQL_FREERESULT($result);

	if ($value > 0)
	{
		define('__TASK_DELETED_VALUE', "<A href=\"".URL."/modules.php?module=admin&amp;what=list_task&amp;type=deleted\">".$value."</A>");
	}
	 else
	{
		define('__TASK_DELETED_VALUE', "0");
	}
	//
	// Solved tasks
	//
	$result = SQL_QUERY_ESC("SELECT id FROM "._MYSQL_PREFIX."_task_system WHERE status = 'SOLVED' AND assigned_admin='%s'",
	 array(GET_ADMIN_ID($_COOKIE['admin_login'])), __FILE__, __LINE__);
	$value = SQL_NUMROWS($result);
	SQL_FREERESULT($result);

	if ($value > 0)
	{
		define('__TASK_SOLVED_VALUE', "<A href=\"".URL."/modules.php?module=admin&amp;what=list_task&amp;type=solved\">".$value."</A>");
	}
	 else
	{
		define('__TASK_SOLVED_VALUE', "0");
	}
	//
	// Your tasks
	//
	$result = SQL_QUERY_ESC("SELECT id FROM "._MYSQL_PREFIX."_task_system WHERE assigned_admin='%s' AND status = 'NEW' AND task_type != 'EXTENSION_UPDATE'",
	 array(GET_ADMIN_ID($_COOKIE['admin_login'])), __FILE__, __LINE__);
	$value = SQL_NUMROWS($result);
	SQL_FREERESULT($result);

	if ($value > 0)
	{
		define('__TASK_YOUR_VALUE', "<A href=\"".URL."/modules.php?module=admin&amp;what=list_task\">".$value."</A>");
	}
	 else
	{
		define('__TASK_YOUR_VALUE', "0");
	}
	//
	// Mails waiting to be approved
	//
	$result = SQL_QUERY("SELECT id FROM "._MYSQL_PREFIX."_pool WHERE data_type='ADMIN'", __FILE__, __LINE__);
	$value = SQL_NUMROWS($result);
	SQL_FREERESULT($result);

	if ($value > 0)
	{
		define('__MAIL_ADMIN_VALUE', "<A href=\"".URL."/modules.php?module=admin&amp;what=unlock_emails\">".$value."</A>");
	}
	 else
	{
		define('__MAIL_ADMIN_VALUE', "0");
	}
	//
	// Unfinished mail orders
	//
	$result = SQL_QUERY("SELECT id FROM "._MYSQL_PREFIX."_pool WHERE data_type='TEMP'", __FILE__, __LINE__);
	$value = SQL_NUMROWS($result);
	SQL_FREERESULT($result);

	if ($value > 0)
	{
		define('__MAIL_TEMP_VALUE', "<A href=\"".URL."/modules.php?module=admin&amp;what=email_details\">".$value."</A>");
	}
	 else
	{
		define('__MAIL_TEMP_VALUE', "0");
	}
	//
	// Sent mail orders
	//
	$result = SQL_QUERY("SELECT id FROM "._MYSQL_PREFIX."_pool WHERE data_type='SEND'", __FILE__, __LINE__);
	$value = SQL_NUMROWS($result);
	SQL_FREERESULT($result);

	if ($value > 0)
	{
		define('__MAIL_SEND_VALUE', "<A href=\"".URL."/modules.php?module=admin&amp;what=email_archiv\">".$value."</A>");
	}
	 else
	{
		define('__MAIL_SEND_VALUE', "0");
	}
	//
	// Autopurged mails
	//
	if (EXT_IS_ACTIVE("autopurge"))
	{
		$result = SQL_QUERY("SELECT id FROM "._MYSQL_PREFIX."_pool WHERE data_type='DELETED'", __FILE__, __LINE__);
		$value = SQL_NUMROWS($result);
		SQL_FREERESULT($result);

		if ($value > 0)
		{
			define('__MAIL_DELETED_VALUE', "<A href=\"".URL."/modules.php?module=admin&amp;what=email_details\">".$value."</A>");
		}
		 else
		{
			define('__MAIL_DELETED_VALUE', "0");
		}
		//
		// Autopurged bonus mails
		//
		if (GET_EXT_VERSION("bonus") >= "0.1.8")
		{
			$result = SQL_QUERY("SELECT id FROM "._MYSQL_PREFIX."_bonus WHERE data_type='DELETED'", __FILE__, __LINE__);
			$value = SQL_NUMROWS($result);
			SQL_FREERESULT($result);

			if ($value > 0)
			{
				define('__MAIL_BONUS_AP_VALUE', "<A href=\"".URL."/modules.php?module=admin&amp;what=email_details\">".$value."</A>");
			}
			 else
			{
				define('__MAIL_BONUS_AP_VALUE', "0");
			}
		}
		 elseif (EXT_IS_ACTIVE("bonus"))
		{
			define('__MAIL_BONUS_AP_VALUE', ADMIN_EXT_BONUS_OUTDATED_1."0.1.8".ADMIN_EXT_BONUS_OUTDATED_2);
		}
		 else
		{
			define('__MAIL_BONUS_AP_VALUE', "<FONT class=\"admin_note\">".ADMIN_EXT_BONUS_404."</FONT>");
		}
	}
	 else
	{
		define('__MAIL_BONUS_AP_VALUE', "<FONT class=\"admin_note\">".ADMIN_EXT_AUTOPURGE_404."</FONT>");
		define('__MAIL_DELETED_VALUE', "<FONT class=\"admin_note\">".ADMIN_EXT_AUTOPURGE_404."</FONT>");
	}
	//
	// Sent bonus mails
	//
	if (GET_EXT_VERSION("bonus") >= "0.1.8")
	{
		$result = SQL_QUERY("SELECT id FROM "._MYSQL_PREFIX."_bonus WHERE data_type='SEND'", __FILE__, __LINE__);
		$value = SQL_NUMROWS($result);
		SQL_FREERESULT($result);

		if ($value > 0)
		{
			define('__MAIL_BONUS_SEND_VALUE', "<A href=\"".URL."/modules.php?module=admin&amp;what=email_details\">".$value."</A>");
		}
		 else
		{
			define('__MAIL_BONUS_SEND_VALUE', "0");
		}
	}
	 elseif (EXT_IS_ACTIVE("bonus"))
	{
		define('__MAIL_BONUS_SEND_VALUE', ADMIN_EXT_BONUS_OUTDATED_1."0.1.8".ADMIN_EXT_BONUS_OUTDATED_2);
	}
	 else
	{
		define('__MAIL_BONUS_SEND_VALUE', ADMIN_EXT_BONUS_404);
	}
	if (EXT_IS_ACTIVE("autopurge"))
	{
		// Start finding them...
		$since = (time() - $CONFIG['ap_in_since']);
		$EXCLUDE_LIST = " AND d.userid != c.def_refid";

		// Check for more extensions
		if (EXT_IS_ACTIVE("beg"))     $EXCLUDE_LIST .= " AND d.userid != c.beg_uid";
		if (EXT_IS_ACTIVE("bonus"))   $EXCLUDE_LIST .= " AND d.userid != c.bonus_uid";
		if (EXT_IS_ACTIVE("doubler")) $EXCLUDE_LIST .= " AND d.userid != c.doubler_uid";

		// Check for new holiday system
		if (GET_EXT_VERSION("holiday") >= "0.1.3")
		{
			$EXCLUDE_LIST .= " AND d.holiday_active = 'N'";
		}

		// Check for all accounts
		$SQLs[] = "SELECT DISTINCT d.userid, d.email, d.last_online
FROM "._MYSQL_PREFIX."_user_data AS d, "._MYSQL_PREFIX."_config AS c
WHERE d.status='CONFIRMED' AND d.joined < ".$since." AND d.last_online < ".$since." AND d.ap_notified < ".$since."
".$EXCLUDE_LIST."
ORDER BY d.userid";
		$WHATs[]  = "list_autopurge";
		$DESCRs[] = TASK_ADMIN_INACTIVE_AUTOPURGE;
		$TITLEs[] = TASK_ADMIN_INACTIVE_AUTOPURGE_TITLE;
	}
	if (GET_EXT_VERSION("sql_patches") >= "0.3.4")
	{
		// Check for accounts without referral
		$SQLs[]   = "SELECT userid FROM "._MYSQL_PREFIX."_user_data WHERE refid='0' ORDER BY userid";
		$DESCRs[] = TAKS_ADMIN_LIST_ACCOUNT_NOREF;
		$TITLEs[] = TAKS_ADMIN_LIST_ACCOUNT_NOREF_TITLE;
		$WHATs[]  = "list_norefs";
	}
	if (EXT_IS_ACTIVE("payout"))
	{
		// List new payout requests
		$SQLs[]   = "SELECT userid FROM "._MYSQL_PREFIX."_user_payouts WHERE status='NEW' ORDER BY userid";
		$WHATs[]  = "list_payouts";
		$DESCRs[] = TASK_ADMIN_LIST_PAYOUTS_WAITING;
		$TITLEs[] = TASK_ADMIN_LIST_PAYOUTS_WAITING_TITLE;
		$SQLs[]   = "SELECT userid FROM "._MYSQL_PREFIX."_user_payouts ORDER BY userid";
		$WHATs[]  = "list_payouts";
		$DESCRs[] = TASK_ADMIN_LIST_PAYOUTS_ALL;
		$TITLEs[] = TASK_ADMIN_LIST_PAYOUTS_ALL_TITLE;
	}
	if (EXT_IS_ACTIVE("wernis"))
	{
		// List new wernis requests
		$SQLs[]   = "SELECT userid FROM "._MYSQL_PREFIX."_user_wernis ORDER BY userid";
		$WHATs[]  = "list_wernis";
		$DESCRs[] = TASK_ADMIN_LIST_WERNIS_ALL;
		$TITLEs[] = TASK_ADMIN_LIST_WERNIS_ALL_TITLE;
	}
	if (EXT_IS_ACTIVE("holiday"))
	{
		// List holiday requests
		$SQLs[]   = "SELECT userid FROM "._MYSQL_PREFIX."_user_holidays ORDER BY userid";
		$WHATs[]  = "list_holiday";
		$DESCRs[] = TASK_ADMIN_LIST_HOLIDAYS;
		$TITLEs[] = TASK_ADMIN_LIST_HOLIDAYS_TITLE;
	}
	if (GET_EXT_VERSION("bonus") >= "0.2.3")
	{
		// Active rallye
		if (GET_EXT_VERSION("bonus") >= "0.6.9")
		{
			// Add more bonus points here
			$USE = "(0";
			if ($CONFIG['bonus_click_yn'] == "Y") $USE .= " + turbo_bonus";
			if ($CONFIG['bonus_login_yn'] == "Y") $USE .= " + login_bonus";
			if ($CONFIG['bonus_order_yn'] == "Y") $USE .= " + bonus_order";
			if ($CONFIG['bonus_stats_yn'] == "Y") $USE .= " + bonus_stats";
			if ($CONFIG['bonus_ref_yn']   == "Y") $USE .= " + bonus_ref";
			$USE .= ")";
		}
		 else
		{
			// Old version ???
			$USE = "turbo_bonus";
		}

		// Autopurge installed?
		$LAST = ""; $ONLINE = "";
		if ((EXT_IS_ACTIVE("autopurge")) && ($CONFIG['ap_inactive'] == "Y") && ($CONFIG['ap_in_since'] > 0))
		{
			// Use last online timestamp to keep inactive members away from here
			$LAST   = " AND last_online >= ";
			$ONLINE = bigintval(time() - $CONFIG['ap_in_since']);
		}

		$SQLs[]   = "SELECT ".$USE." AS active_bonus FROM "._MYSQL_PREFIX."_user_data
WHERE status='CONFIRMED' AND ".$USE.">0".$LAST."".$ONLINE."
ORDER BY active_bonus DESC, userid";
		$WHATs[]  = "list_bonus";
		$DESCRs[] = TASK_ADMIN_LIST_BONUS;
		$TITLEs[] = TASK_ADMIN_LIST_BONUS_TITLE;
	}
	if (GET_EXT_VERSION("beg") >= "0.1.2")
	{
		// Begging rallye

		// Autopurge installed?
		$LAST = ""; $ONLINE = "";
		if ((EXT_IS_ACTIVE("autopurge")) && ($CONFIG['ap_inactive'] == "Y") && ($CONFIG['ap_in_since'] > 0))
		{
			// Use last online timestamp to keep inactive members away from here
			$LAST   = " AND last_online >= ";
			$ONLINE = bigintval(time() - $CONFIG['ap_in_since']);
		}

		$SQLs[]   = "SELECT userid FROM "._MYSQL_PREFIX."_user_data
WHERE status='CONFIRMED' AND beg_points>0".$LAST."".$ONLINE."
ORDER BY beg_points DESC, userid";
		$WHATs[]  = "list_beg";
		$DESCRs[] = TASK_ADMIN_LIST_BEG;
		$TITLEs[] = TASK_ADMIN_LIST_BEG_TITLE;
	}
	if (EXT_IS_ACTIVE("doubler"))
	{
		// List waiting payouts
		$SQLs[]   = "SELECT id FROM "._MYSQL_PREFIX."_doubler WHERE completed='N' ORDER BY id";
		$WHATs[]  = "list_doubler&amp;mode=waiting&amp;select=all";
		$DESCRs[] = TASK_ADMIN_LIST_DOUBLER_WAITING;
		$TITLEs[] = TASK_ADMIN_LIST_DOUBLER_WAITING_TITLE;
		$SQLs[]   = "SELECT id FROM "._MYSQL_PREFIX."_doubler ORDER BY id";
		$WHATs[]  = "list_doubler";
		$DESCRs[] = TASK_ADMIN_LIST_DOUBLER_ALL;
		$TITLEs[] = TASK_ADMIN_LIST_DOUBLER_ALL_TITLE;
	}
	//
	// All referral banner
	//
	$SQLs[] = "SELECT id FROM "._MYSQL_PREFIX."_refbanner ORDER BY id";
	$WHATs[] = "refbanner";
	$DESCRs[] = TASK_ADMIN_LIST_REFBANNER_ALL;
	$TITLEs[] = TASK_ADMIN_LIST_REFBANNER_ALL_TITLE;
	//
	// All activated referral banner
	//
	$SQLs[] = "SELECT id FROM "._MYSQL_PREFIX."_refbanner WHERE visible='Y' ORDER BY id";
	$WHATs[] = "refbanner";
	$DESCRs[] = TASK_ADMIN_LIST_REFBANNER_ACTIVE;
	$TITLEs[] = TASK_ADMIN_LIST_REFBANNER_ACTIVE_TITLE;
	//
	// All extensions
	//
	$SQLs[] = "SELECT id FROM "._MYSQL_PREFIX."_extensions ORDER BY id";
	$WHATs[] = "extensions";
	$DESCRs[] = TASK_ADMIN_LIST_EXTENSIONS_ALL;
	$TITLEs[] = TASK_ADMIN_LIST_EXTENSIONS_ALL_TITLE;
	//
	// All activated extensions
	//
	$SQLs[] = "SELECT id FROM "._MYSQL_PREFIX."_extensions WHERE ext_active='Y' ORDER BY id";
	$WHATs[] = "extensions";
	$DESCRs[] = TASK_ADMIN_LIST_EXTENSIONS_ACTIVE;
	$TITLEs[] = TASK_ADMIN_LIST_EXTENSIONS_ACTIVE_TITLE;
	//
	if (EXT_IS_ACTIVE("engine"))
	{
		// List all export accounts
		$SQLs[] = "SELECT id FROM "._MYSQL_PREFIX."_engine_accounts ORDER BY id";
		$WHATs[] = "list_engine";
		$DESCRs[] = TASK_ADMIN_LIST_ENGINE;
		// List all pending accounts
		$SQLs[] = "SELECT id FROM "._MYSQL_PREFIX."_engine_accounts WHERE status='UNCONFIRMED' ORDER BY id";
		$WHATs[] = "unlock_engine";
		$DESCRs[] = TASK_ADMIN_UNLOCK_ENGINE;
		// List all safes
		$SQLs[] = "SELECT id FROM "._MYSQL_PREFIX."_engine_safe ORDER BY id";
		$WHATs[] = "list_engine&amp;mode=safe";
		$DESCRs[] = TASK_ADMIN_LIST_ENGINE_SAFES;
		// List all export URLs
		$SQLs[] = "SELECT id FROM "._MYSQL_PREFIX."_engine_urls ORDER BY id";
		$WHATs[] = "engine_urls";
		$DESCRs[] = TASK_ADMIN_LIST_ENGINE_URLS;
	}
	if (EXT_IS_ACTIVE("sponsor"))
	{
		// List all sponsors
		$SQLs[]   = "SELECT id FROM "._MYSQL_PREFIX."_sponsor_data ORDER BY id";
		$WHATs[]  = "list_sponsor";
		$DESCRs[] = TASK_ADMIN_LIST_SPONSOR;
		$TITLEs[] = TASK_ADMIN_LIST_SPONSOR_TITLE;
		// List confirmed sponsor accounts
		$SQLs[]   = "SELECT id FROM "._MYSQL_PREFIX."_sponsor_data WHERE status='CONFIRMED' ORDER BY id";
		$WHATs[]  = "list_sponsor";
		$DESCRs[] = TASK_ADMIN_LIST_SPONSOR_CONFIRMED;
		$TITLEs[] = TASK_ADMIN_LIST_SPONSOR_CONFIRMED_TITLE;
		// List unconfirmed sponsor accounts
		$SQLs[]   = "SELECT id FROM "._MYSQL_PREFIX."_sponsor_data WHERE status='UNCONFIRMED' ORDER BY id";
		$WHATs[]  = "list_sponsor";
		$DESCRs[] = TASK_ADMIN_LIST_SPONSOR_UNCONFIRMED;
		$TITLEs[] = TASK_ADMIN_LIST_SPONSOR_UNCONFIRMED_TITLE;
		// List locked sponsor accounts
		$SQLs[]   = "SELECT id FROM "._MYSQL_PREFIX."_sponsor_data WHERE status='LOCKED' ORDER BY id";
		$WHATs[]  = "list_sponsor";
		$DESCRs[] = TASK_ADMIN_LIST_SPONSOR_LOCKED;
		$TITLEs[] = TASK_ADMIN_LIST_SPONSOR_LOCKED_TITLE;
		// List waiting sponsor accounts to be approved
		$SQLs[]   = "SELECT id FROM "._MYSQL_PREFIX."_sponsor_data WHERE status='PENDING' ORDER BY id";
		$WHATs[]  = "unlock_sponsor";
		$DESCRs[] = TASK_ADMIN_LIST_SPONSOR_PENDING;
		$TITLEs[] = TASK_ADMIN_LIST_SPONSOR_PENDING_TITLE;
		// Waiting payments
		$SQLs[]   = "SELECT id FROM "._MYSQL_PREFIX."_sponsor_orders WHERE pay_status='PENDING' ORDER BY id";
		$WHATs[]  = "list_sponsor_pays";
		$DESCRs[] = TASK_ADMIN_LIST_SPONSOR_ORDERS;
		$TITLEs[] = TASK_ADMIN_LIST_SPONSOR_ORDERS_TITLE;
	}
	if (EXT_IS_ACTIVE("country"))
	{
		// List country codes
		$SQLs[]   = "SELECT id FROM "._MYSQL_PREFIX."_countries ORDER BY id";
		$WHATs[]  = "list_country";
		$DESCRs[] = TASK_ADMIN_LIST_COUNTRY;
		$TITLEs[] = TASK_ADMIN_LIST_COUNTRY_TITLE;
	}
	if (EXT_IS_ACTIVE("theme"))
	{
		// List all themes
		$SQLs[]   = "SELECT id FROM "._MYSQL_PREFIX."_themes ORDER BY id";
		$WHATs[]  = "theme_edit";
		$DESCRs[] = TASK_ADMIN_LIST_THEME_ALL;
		$TITLEs[] = TASK_ADMIN_LIST_THEME_ALL_TITLE;
		// List active themes
		$SQLs[]   = "SELECT id FROM "._MYSQL_PREFIX."_themes WHERE theme_active='Y' ORDER BY id";
		$WHATs[]  = "theme_edit";
		$DESCRs[] = TASK_ADMIN_LIST_THEME_ACTIVE;
		$TITLEs[] = TASK_ADMIN_LIST_THEME_ACTIVE_TITLE;
	}
	if (EXT_IS_ACTIVE("admins"))
	{
		// List all administrator logins
		$SQLs[]   = "SELECT id FROM "._MYSQL_PREFIX."_admins ORDER BY id";
		$WHATs[]  = "admins_edit";
		$DESCRs[] = TASK_ADMIN_LIST_ADMINS_ALL;
		$TITLEs[] = TASK_ADMIN_LIST_ADMINS_ALL_TITLE;
	}

	// Generate extra overview rows
	$EXTRAS .= TASK_CREATE_EXTRA_ROWS($SQLs, $WHATs, $DESCRs, $TITLEs);

	// If empty just keep a forced-space left for CSS issues
	if (empty($EXTRAS)) $EXTRAS = "&nbsp;";

	// Add compiled string to constant for final template
	define('__OVERVIEW_EXTRA_TABLE', $EXTRAS);

	// Simply load the template... :-)
	LOAD_TEMPLATE("admin_overview_task");
}
//
function TASK_CREATE_EXTRA_ROWS($SQLs, $WHATs, $DESCRs, $TITLEs)
{
	$OUT = ""; $SW = 2; $MAX = sizeof($SQLs) - 1;
	foreach ($SQLs as $key=>$sql)
	{
		// Run SQL command, get line numbers and free memory
		$result = SQL_QUERY($sql, __FILE__, __LINE__);
		$value = SQL_NUMROWS($result);
		SQL_FREERESULT($result);

		$content = array(
			'row_descr' => $DESCRs[$key],
			'row_sw'    => $SW,
			'bottom'    => "",
		);
		if ($key < $MAX) $content['bottom'] = "bottom2";
		if (($value > 0) && (!empty($WHATs[$key])))
		{
			if (empty($TITLEs[$key])) $TITLEs[$key] = TASK_ADMIN_UNKNOWN_LIST_TITLE;
			$content['row_link'] = "<A href=\"".URL."/modules.php?module=admin&amp;what=".$WHATs[$key]."\" title=\"".$TITLEs[$key]."\">".$value."</A>";
		}
		 else
		{
			$content['row_link'] = "0";
		}

		// Switch color
		$SW = 3 - $SW;

		// And insert the final string into extras template
		$OUT .= LOAD_TEMPLATE("admin_overview_task_rows", true, $content);
	}

	// Return output
	return LOAD_TEMPLATE("admin_overview_task_extras", true, $OUT);
}
//
?>
