<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 08/27/2004 *
 * ================                             Last change: 08/27/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-config_mods.php                             *
 * -------------------------------------------------------------------- *
 * Short description : Module configuration                             *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Modul-Konfiguration                              *
 * -------------------------------------------------------------------- *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2007 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if ((ereg(basename(__FILE__), $_SERVER['PHP_SELF'])) || (!IS_ADMIN()))
{
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), "/inc") + 4)."/security.php";
	require($INC);
}
// Add description as navigation point
ADD_DESCR("admin", basename(__FILE__));

$SEL = 0;
if (isset($_POST['edit']))
{
	// Check if at least one module is selected
	$SEL = SELECTION_COUNT($_POST['sel']);
	if ($SEL > 0)
	{
		// Output header
		$OUT = ""; $SW = 2;

		// Edit selected modules
		foreach ($_POST['sel'] as $id=>$sel)
		{
			// Load module data
			$result = SQL_QUERY_ESC("SELECT module, title, locked, hidden, admin_only, mem_only FROM "._MYSQL_PREFIX."_mod_reg WHERE id=%d LIMIT 1",
			 array(bigintval($id)), __FILE__, __LINE__);
			list($mod, $title, $locked, $hidden, $admin, $mem) = SQL_FETCHROW($result);
			SQL_FREERESULT($result);

			// Prepare array for the template
			$content = array(
				'sw'     => $SW,
				'mod'    => $mod,
				'id'     => $id,
				'title'  => $title,
				'locked' => ADD_SELECTION("yn", $locked, "locked", $id),
				'hidden' => ADD_SELECTION("yn", $hidden, "hidden", $id),
				'admin'  => ADD_SELECTION("yn", $admin , "admin" , $id),
				'mem'    => ADD_SELECTION("yn", $mem   , "member", $id),
			);

			// Load row template
			$OUT .= LOAD_TEMPLATE("admin_mods_edit_row", true, $content);
		}
		define('__MODS_ROWS', $OUT);

		// Load main template
		LOAD_TEMPLATE("admin_mods_edit");
	}
	 else
	{
		// Nothing selected
		LOAD_TEMPLATE("admin_settings_saved", false, MODS_NOTHING_SELECTED);
		OUTPUT_HTML ("<BR>");

		// Remove maybe confusing data
		unset($_POST['edit']);
		unset($_POST['change']);
	}
}
 elseif (isset($_POST['change']))
{
	// Change modules
	foreach ($_POST['sel'] as $id=>$sel)
	{
		// Secure ID number
		$id = bigintval($id);

		// Update module
		$result = SQL_QUERY_ESC("UPDATE "._MYSQL_PREFIX."_mod_reg SET title='%s', locked='%s', hidden='%s', admin_only='%s', mem_only='%s' WHERE id=%d LIMIT 1",
		 array($_POST['title'][$id], $_POST['locked'][$id], $_POST['hidden'][$id], $_POST['admin'][$id], $_POST['member'][$id], $id),  __FILE__, __LINE__);
	}

	// Remove cache file if version matches
	if (GET_EXT_VERSION("cache") >= "0.1.2")
	{
		if ($CACHE->cache_file("mod_reg", true)) $CACHE->cache_destroy();
	}

	// Entries updated
	LOAD_TEMPLATE("admin_settings_saved", false, MODS_CHANGED);
	OUTPUT_HTML ("<BR>");
}

if ($SEL == 0)
{
	// Load module data (We do not need to check if there's at least one...)
	$result = SQL_QUERY("SELECT id, module, locked, hidden, admin_only, title, mem_only, clicks
FROM "._MYSQL_PREFIX."_mod_reg
ORDER BY module", __FILE__, __LINE__);
	$OUT = ""; $SW = 2;
	while (list($id, $mod, $locked, $hidden, $admin, $title, $mem) = SQL_FETCHROW($result))
	{
		// Reset title to --- if it is NULL
		if (empty($title)) $title = "---";
		if (($mod == "index") || ($mod == "login"))
		{
			// Add link to detail statistics
			$mod = "<STRONG><A href=\"".URL."/modules.php?module=admin&amp;what=stats_mods&amp;mod=".$mod."\">".$mod."</A></STRONG>";
		}

		// Prepare array for the template
		$content = array(
			'sw'     => $SW,
			'id'     => $id,
			'mod'    => $mod,
			'title'  => $title,
			'locked' => TRANSLATE_YESNO($locked),
			'hidden' => TRANSLATE_YESNO($hidden),
			'admin'  => TRANSLATE_YESNO($admin),
			'mem'    => TRANSLATE_YESNO($mem),
		);

		// Load row template
		$OUT .= LOAD_TEMPLATE("admin_mods_list_row", true, $content);

		// Switch colors
		$SW = 3 - $SW;
	}

	// Free memory
	SQL_FREERESULT($result);
	define('__MODS_ROWS', $OUT);

	// Load main template
	LOAD_TEMPLATE("admin_mods_list");
}

//
?>
