<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 12/14/2003 *
 * ================                             Last change: 08/22/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-stats.php                                   *
 * -------------------------------------------------------------------- *
 * Short description : Statistics                                       *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Statistiken                                      *
 * -------------------------------------------------------------------- *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2007 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (ereg(basename(__FILE__), $_SERVER['PHP_SELF']))
{
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), "/inc") + 4)."/security.php";
	require($INC);
}
// Add description as navigation point
ADD_DESCR("guest", basename(__FILE__));

// Derterminate which stats we want and set mode and title for the link below stats block
if (!isset($_GET['mode'])) $_GET['mode'] = strtolower($CONFIG['gstats_mode']);
switch ($_GET['mode'])
{
	case "members": $CONFIG['gstats_mode'] = "MEMBERS"; $lmode = "modules"; $ltitle = GUEST_STATS_MODULES; break;
	case "modules": $CONFIG['gstats_mode'] = "MODULES"; $lmode = "members"; $ltitle = GUEST_STATS_MEMBERS; break;
}

OPEN_TABLE("100%", "guest_content", "center", "top");
switch ($CONFIG['gstats_mode'])
{
case "MEMBERS": // Statistics about your members
	// Members yesterday / today online
	$ymem = SQL_NUMROWS(SQL_QUERY("SELECT userid FROM "._MYSQL_PREFIX."_user_data WHERE last_online >= ".START_YDAY." AND last_online < ".START_TDAY." AND status='CONFIRMED'", __FILE__, __LINE__));
	$tmem = SQL_NUMROWS(SQL_QUERY("SELECT userid FROM "._MYSQL_PREFIX."_user_data WHERE last_online >= ".START_TDAY." AND status='CONFIRMED'", __FILE__, __LINE__));

	// Yesterday / today registered
	$yreg = SQL_NUMROWS(SQL_QUERY("SELECT userid FROM "._MYSQL_PREFIX."_user_data WHERE joined >= ".START_YDAY." AND joined < ".START_TDAY, __FILE__, __LINE__));
	$treg = SQL_NUMROWS(SQL_QUERY("SELECT userid FROM "._MYSQL_PREFIX."_user_data WHERE joined >= ".START_TDAY, __FILE__, __LINE__));

	// Only males / females
	$male   = SQL_NUMROWS(SQL_QUERY("SELECT userid FROM "._MYSQL_PREFIX."_user_data WHERE sex='M' AND status='CONFIRMED'", __FILE__, __LINE__));
	$female = SQL_NUMROWS(SQL_QUERY("SELECT userid FROM "._MYSQL_PREFIX."_user_data WHERE sex='F' AND status='CONFIRMED'", __FILE__, __LINE__));

	// Unconfirmed accounts
	$unconfirmed = SQL_NUMROWS(SQL_QUERY("SELECT userid FROM "._MYSQL_PREFIX."_user_data WHERE status != 'CONFIRMED'", __FILE__, __LINE__));

	// Total members
	$total = $male + $female;

	// List every month
	$months = array();
	for ($idx = 1; $idx < 13; $idx++)
	{
		$month = $idx; if ($idx < 10) $month = "0".$idx;
		$months[$month] = SQL_NUMROWS(SQL_QUERY_ESC("SELECT userid FROM "._MYSQL_PREFIX."_user_data WHERE birth_month=%d AND status='CONFIRMED'",
		 array(bigintval($month)), __FILE__, __LINE__));
	}

	// Members in categories
	$result = SQL_QUERY("SELECT id, cat FROM "._MYSQL_PREFIX."_cats WHERE visible='Y' ORDER BY id", __FILE__, __LINE__);

	// Load categories first
	$cats = array(); $cat_cnt = array();
	while (list($id, $cat) = SQL_FETCHROW($result))
	{
		// Simple...
		$cats[$id] = $cat;
	}

	// Now we have all categories loaded, count members
	foreach ($cats as $id=>$dummy)
	{
		// We only need id and nothing more to count...
		$cat_cnt[$id] = SQL_NUMROWS(SQL_QUERY_ESC("SELECT id FROM "._MYSQL_PREFIX."_user_cats WHERE cat_id=%d",
		 array(bigintval($id)), __FILE__, __LINE__));
	}

	// Prepare data for the template
	define('__TOTAL_USERS' , $total);
	define('__UNCONFIRMED' , $unconfirmed);
	define('__MALE_COUNT'  , $male);
	define('__FEMALE_COUNT', $female);
	define('__TMEM_COUNT'  , $tmem);
	define('__YMEM_COUNT'  , $ymem);
	define('__TREG_COUNT'  , $treg);
	define('__YREG_COUNT'  , $yreg);
	define('__LMODE_VALUE' , $lmode);
	define('__LINK_TITLE'  , $ltitle);

	// Generate monthly stats
	$SW = 2; $r2 = " right2"; $l = "ll"; $r = "lr"; $OUT = "";
	foreach ($months as $month=>$cnt)
	{
		if ($SW == 2) $OUT .= "<TR>\n";

		// Prepare data for template
		$content = array(
			'l_class'  => $l,
			'm_descr'  => $MONTH_DESCR[$month],
			'r_class'  => $r,
			'r2_class' => $r2,
			'cnt'      => $cnt
		);

		// Load row template
		$OUT .= LOAD_TEMPLATE("guest_stats_month_row", true, $content);

		if ($SW == 2)
		{
			$r2 = "";
			$l = "rl"; $r = "rr";
		}
		 else
		{
			$OUT .= "</TR>\n";
			$r2 = " right2";
			$l = "ll"; $r = "lr";
		}
		$SW = 3 - $SW;
	}
	define('__MONTH_STATS_ROWS', $OUT);

	// Generate category stats
	$SW = 2; $OUT = "";
	foreach ($cat_cnt as $id=>$cnt)
	{
		// Prepare data for the template
		$content = array(
			'sw'  => $SW,
			'cat' => $cats[$id],
			'cnt' => $cnt,
		);

		// Load row template and switch colors
		$OUT .= LOAD_TEMPLATE("guest_stats_cats_row", true, $content);
		$SW = 3 - $SW;
	}
	define('__CATS_STATS_ROWS', $OUT);

	// Load final template
	LOAD_TEMPLATE("guest_stats_member");
	break;

case "MODULES": // TOP10 module clicks
	$AND = "";
	if (!IS_ADMIN()) $AND = " AND locked='N' AND visible='Y'";
	$guest_t10 = SQL_QUERY("SELECT counter, title FROM "._MYSQL_PREFIX."_guest_menu WHERE counter > 0".$AND." ORDER BY counter DESC LIMIT 0,10", __FILE__, __LINE__);
	$mem_t10   = SQL_QUERY("SELECT counter, title FROM "._MYSQL_PREFIX."_member_menu WHERE counter > 0".$AND." ORDER BY counter DESC LIMIT 0,10", __FILE__, __LINE__);
	if ((SQL_NUMROWS($guest_t10) > 0) || (SQL_NUMROWS($mem_t10) > 0))
	{
		// Output header
		OUTPUT_HTML ("<TABLE border=\"0\" cellspacing=\"0\" cellpadding=\"0\" class=\"guest_table dashed\" width=\"310\">
<TR>
  <TD align=\"center\" class=\"guest_stats_title bottom2\" colspan=\"2\"><STRONG>".GUEST_TOPTEN_STATS."</STRONG></TD>
</TR>");
	}

	if (SQL_NUMROWS($guest_t10) > 0)
	{
		// Guest clicks
		OUTPUT_HTML ("<TR>
  <TD align=\"center\" class=\"guest_title2 bottom2\" colspan=\"2\">".GUEST_TOP_GUEST_STATS."</TD>
</TR>");
		$SW = 2;
		while (list($clicks, $title) = SQL_FETCHROW($guest_t10))
		{
			OUTPUT_HTML ("<TR>
  <TD class=\"switch_sw".$SW." bottom2 right2\" align=\"right\" width=\"250\">".$title."&nbsp;</TD>
  <TD class=\"switch_sw".$SW." bottom2\" width=\"50\">&nbsp;".$clicks."</TD>
</TR>");
			$SW = 3 - $SW;
		}
	}
	if (SQL_NUMROWS($guest_t10) > 0)
	{
		// Guest clicks
		OUTPUT_HTML ("<TR>
  <TD align=\"center\" class=\"guest_title2 bottom2\" colspan=\"2\">".GUEST_TOP_MEMBER_STATS."</TD>
</TR>");
		$SW = 2;
		while (list($clicks, $title) = SQL_FETCHROW($mem_t10))
		{
			OUTPUT_HTML ("<TR>
  <TD class=\"switch_sw".$SW." bottom2 right2\" align=\"right\" width=\"250\">".$title."&nbsp;</TD>
  <TD class=\"switch_sw".$SW." bottom2\" width=\"50\">&nbsp;".$clicks."</TD>
</TR>");
			$SW = 3 - $SW;
		}
	}
	if ((SQL_NUMROWS($guest_t10) > 0) || (SQL_NUMROWS($mem_t10) > 0))
	{
		// Output footer
		OUTPUT_HTML ("<TR>
  <TD align=\"center\" class=\"guest_stats_footer\" colspan=\"2\"><A href=\"".URL."/modules.php?module=index&amp;what=stats&amp;mode=".$lmode."\">".$ltitle."</A></TD>
</TR>
</TABLE>");
	}
	break;

case "INACTIVE": // Deactivated stats
	LOAD_TEMPLATE("admin_settings_saved", false, "<STRONG>".GUEST_STATS_DEACTIVATED."</STRONG>");
	break;
}
CLOSE_TABLE();
//
?>
