<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 02/17/2005 *
 * ================                             Last change: 02/17/2005 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-doubler.php                                 *
 * -------------------------------------------------------------------- *
 * Short description : General doubling informations                    *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Allgemeine Informationen zum Verdoppen           *
 * -------------------------------------------------------------------- *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2007 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (ereg(basename(__FILE__), $_SERVER['PHP_SELF']))
{
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), "/inc") + 4)."/security.php";
	require($INC);
}
 elseif (!IS_LOGGED_IN())
{
	LOAD_URL(URL."/modules.php[5~?module=index");
}
 elseif ((!EXT_IS_ACTIVE("doubler")) && (!IS_ADMIN()))
{
	ADD_FATAL(EXTENSION_PROBLEM_EXT_INACTIVE, "doubler");
	return;
}

// Add description as navigation point
ADD_DESCR("member", basename(__FILE__));

// Percent values etc.
define('__CHARGE_VALUE', TRANSLATE_COMMA($CONFIG['doubler_charge'] * 100));
define('__REF_VALUE'   , TRANSLATE_COMMA($CONFIG['doubler_ref'] * 100));
define('__TOTAL_VALUE' , TRANSLATE_COMMA($CONFIG['doubler_points']));
define('__MIN_VALUE'   , TRANSLATE_COMMA($CONFIG['doubler_min']));
define('__MAX_VALUE'   , TRANSLATE_COMMA($CONFIG['doubler_max']));

// Transfer referral ID
if (EXT_IS_ACTIVE("nickname"))
{
	// Load nickname from DB
	$nick = NICKNAME_GET_NICK($GLOBALS['userid']);

	if (!empty($nick))
	{
		// Set nickname
		define('__USERID', $nick);
	}
	 else
	{
		// Use direct userid
		define('__USERID', $GLOBALS['userid']);
	}
}
 else
{
	// Use direct userid
	define('__USERID', $GLOBALS['userid']);
}

// Usage counter
define('__DOUBLER_COUNTER', $CONFIG['doubler_counter']);

// Which mail-send-mode did the admin setup?
switch ($CONFIG['doubler_send_mode'])
{
case "DIRECT":
	define('DOUBLER_PAYOUT_TIME', DOUBLER_PAYOUT_TIME_DIRECT);
	break;

case "RESET":
	define('DOUBLER_PAYOUT_TIME', DOUBLER_PAYOUT_TIME_RESET);
	break;
}

// Generate table with already payed out doubles
define('__DOUBLER_PAYOUT_HISTORY', DOUBLER_GENERATE_TABLE($GLOBALS['userid'], "Y", "N", "DESC"));

// Generate table with next-to-run payouts
define('__DOUBLER_PAYOUT_NEXT', DOUBLER_GENERATE_TABLE($GLOBALS['userid']));

// Generate table with refferal payouts
define('__DOUBLER_PAYOUT_REF', DOUBLER_GENERATE_TABLE($GLOBALS['userid'], "N", "Y", "DESC"));

// Generate timemark
define('__TIMEOUT_MARK', CREATE_FANCY_TIME($CONFIG['doubler_timeout']));

// Points left to double
define('__LEFT_VALUE', DOUBLER_GET_TOTAL_POINTS_LEFT());

// Load template
LOAD_TEMPLATE("member_doubler");

//
?>
