<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 03/05/2005 *
 * ===============                              Last change: 03/05/2005 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : patch-system.php                                 *
 * -------------------------------------------------------------------- *
 * Short description : Handles patch level                              *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Verwalyet die Patch-Level                        *
 * -------------------------------------------------------------------- *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2007 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (ereg(basename(__FILE__), $_SERVER['PHP_SELF']))
{
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), "/inc") + 4)."/security.php";
	require($INC);
}

// Check for patch level differences between databases and current hard-coded
if (CURR_PATCH_LEVEL > $CONFIG['patch_level'])
{
	// Update database and CONFIG array
	$result = SQL_QUERY("UPDATE "._MYSQL_PREFIX."_config SET patch_level='".CURR_PATCH_LEVEL."', patch_ctime=UNIX_TIMESTAMP() WHERE config='0' LIMIT 1",
	 __FILE__, __LINE__);
	$CONFIG['patch_level'] = CURR_PATCH_LEVEL;
	$CONFIG['patch_ctime'] = time();

	// Destroy cache
	if (GET_EXT_VERSION("cache") >= "0.1.2")
	{
		if ($CACHE->cache_file("config", true))
		{
			// Replace data
			$CACHE->cache_replace("patch_level", $CONFIG['patch_level'], "0", $CFG_CACHE);
			$CACHE->cache_replace("patch_ctime", $CONFIG['patch_ctime'], "0", $CFG_CACHE);
		}
	}
}

//
?>
